$!-----------------------------------------------------------------------------
$! CREATE_SERVER_CERT.COM
$!
$! Create our own server certificate!
$! This procedure is very "quick-and-dirty", use with that in mind!
$!
$! 04-JUN-1999  MGD  OpenSSl-0_9_3 (adapted from earlier procedures)
$!-----------------------------------------------------------------------------
$!
$!(5 * 365 == valid for five years!)
$ days = 1825
$!
$ say = "write sys$output"
$ arch = "AXP"
$ if f$getsyi("cpu") .lt. 128 then arch = "VAX"
$ openSSL = "$HT_ROOT:[SRC.OPENSSL-0_9_3.''arch'.EXE.APPS]OPENSSL"
$!
$ if p1 .eqs. ""
$ then
$    say "p1 must be the name of the certificate file."
$    exit
$ endif
$ if f$parse(p1,,,"type") .eqs. "." then p1 = p1 + ".pem"
$!
$ if p2 .eqs. "" then p2 = "wasd.cnf"
$ if f$parse(p2,,,"type") .eqs. "." then p2 = p2 + ".cnf"
$!
$ on error then goto serverCleanup
$ prevDefault = f$environment("default")
$ set default HT_ROOT:[SRC.OPENSSL-0_9_3.WASD]
$!
$ @CREATE_SUPPORT_FILES
$!
$ say ""
$ say "***** NOTE: the standard WASD CA PEM pass phrase is ""testing"" *****"
$ say "When prompted for ""common name"" the server's full host name should be supplied."
$ say ""
$ define /user sys$input sys$command
$ openSSL req -newkey rsa:512 -verify -new -config 'P2' -
              -outform PEM -out TMPREQ.PEM -keyout TMPKEY1.PEM
$!
$ say ""
$ say "***** SIGN CERTIFICATE *****"
$ say ""
$ define /user sys$input sys$command
$ openSSL ca -days 'DAYS' -policy policy_anything -config 'P2' -
             -outdir ./ -out TMPCERT.PEM -infiles TMPREQ.PEM
$!
$ say ""
$ say "Check for error or report of ""matching entry"""
$ read sys$command line -
       /error=serverCleanup /end=serverCleanup -
       /prompt="Continue if no matching entry [N]: "
$ if .not. line then goto serverCleanup
$!
$ say ""
$ say "***** STRIP PEM PHRASE *****"
$ say ""
$ define /user sys$input sys$command
$ openSSl rsa -in TMPKEY1.PEM -out TMPKEY2.PEM
$!
$ say ""
$ say "***** APPENDING KEY TO CERTIFICATE *****"
$ copy TMPCERT.PEM,TMPKEY2.PEM 'P1'
$!
$ serverCleanup:
$ say ""
$ say "***** FINISHED *****"
$ say ""
$ say "New server certificate is ''P1'"
$ say ""
$ define /user sys$output nl:
$ define /user sys$error nl:
$ delete tmp*.*;*,*.;*,*.;*
$ define /user sys$output nl:
$ define /user sys$error nl:
$ purge /nolog /keep=1 SERIAL.*,INDEX.*,RAND.*
$ set prot=w *.*
$ set prot=w:re CACERT.PEM
$ set prot=w:re CACERT.CRT
$ set default 'prevDefault'
$ exit
$!
$!-----------------------------------------------------------------------------
